/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package wawi.gui.admingui.gui;

import java.awt.Color;
import java.util.Iterator;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import static javax.swing.JOptionPane.showMessageDialog;

import wawi.fachlogik.adminsteuerung.grenz.KategorieGrenz;
import wawi.fachlogik.adminsteuerung.steuer.KategorieSteuerung;
import wawi.gui.admingui.resources.Item;
import wawi.gui.admingui.resources.MyModelComboKategorie;

/**
 *
 * @author gromow
 */
public class FrameKategorieEdit extends javax.swing.JFrame {
private int hiddenValueForComboKategorie;
private MyModelComboKategorie mymodelcombokategorie;
private static KategorieGrenz kategoriegrenz;
private int selectedIndex;

    /**
     * Creates new form FrameKategorieEdit
     */
    public FrameKategorieEdit() {
        
        initComponents();
        fieldID.setText(""+kategoriegrenz.getKatid());
        fieldName.setText(""+kategoriegrenz.getName());
        fieldBeschreibung.setText(""+kategoriegrenz.getBeschreibung());
       
    }

    public void setFieldName(String fieldName) {
        this.fieldName.setText(fieldName);
    }

    public void setFieldID(String fieldName) {
        this.fieldID.setText(fieldName);
    }

    public void setFieldBeschreibung(String fieldBeschreibung) {
        this.fieldBeschreibung.setText(fieldBeschreibung);
    }

    public static void setKategoriegrenz(KategorieGrenz kategoriegrenz) {
        FrameKategorieEdit.kategoriegrenz = kategoriegrenz;
    }
    
    
 

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        fieldName = new javax.swing.JTextField();
        jLabel2 = new javax.swing.JLabel();
        fieldBeschreibung = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        kategorieSave = new javax.swing.JButton();
        close = new javax.swing.JButton();
        jLabel4 = new javax.swing.JLabel();
        fieldID = new javax.swing.JTextField();
        jLabel5 = new javax.swing.JLabel();
        lblOutput = new javax.swing.JLabel();
        ComboKategorie = new javax.swing.JComboBox<>();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        jLabel1.setText("Name*");

        jLabel2.setText("Beschreibung*");

        jLabel3.setText("Parentkategorie*");

        kategorieSave.setText("Speichern");
        kategorieSave.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                kategorieSaveActionPerformed(evt);
            }
        });

        close.setText("Abbrechen");
        close.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeActionPerformed(evt);
            }
        });

        jLabel4.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel4.setText("Kategorie bearbeiten");

        fieldID.setEditable(false);

        jLabel5.setText("ID");

        mymodelcombokategorie = new MyModelComboKategorie();
        ComboKategorie.setModel(new javax.swing.DefaultComboBoxModel<>(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));
        ComboKategorie.setModel(mymodelcombokategorie.buildTableModel(true));

        //todo
        DefaultComboBoxModel dc = mymodelcombokategorie.buildTableModel(true);

        for(int i = 0;i<dc.getSize();i++){
            Item item = (Item)dc.getElementAt(i);
            if(item.getId() == kategoriegrenz.getParentkatid()){
                selectedIndex =  i;

                hiddenValueForComboKategorie=kategoriegrenz.getParentkatid();
            }
        }
        ComboKategorie.setSelectedIndex(selectedIndex);
        //todo
        ComboKategorie.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ComboKategorieActionPerformed(evt);
            }
        });
        ComboKategorie.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ComboKategorieActionPerformed(evt);
                JComboBox combo = (JComboBox)evt.getSource();
                Item item = (Item) combo.getSelectedItem();
                //String currentQuantity = (String)combo.getSelectedItem();
                hiddenValueForComboKategorie = item.getId();
                lblOutput.setText("Kategorie: "+hiddenValueForComboKategorie);

            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2)
                            .addComponent(jLabel3)
                            .addComponent(jLabel5))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(fieldName, javax.swing.GroupLayout.DEFAULT_SIZE, 443, Short.MAX_VALUE)
                            .addComponent(fieldID)
                            .addComponent(ComboKategorie, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(fieldBeschreibung)))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(lblOutput)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 388, Short.MAX_VALUE)
                        .addComponent(close, javax.swing.GroupLayout.PREFERRED_SIZE, 100, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(kategorieSave, javax.swing.GroupLayout.PREFERRED_SIZE, 94, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel4)
                .addGap(37, 37, 37)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(fieldID, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel5))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(fieldName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(fieldBeschreibung, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(ComboKategorie, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(11, 11, 11)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(kategorieSave)
                    .addComponent(close)
                    .addComponent(lblOutput))
                .addContainerGap(12, Short.MAX_VALUE))
        );

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {close, kategorieSave});

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {fieldBeschreibung, fieldName});

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void closeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeActionPerformed
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        dispose();
    }//GEN-LAST:event_closeActionPerformed

    private void kategorieSaveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_kategorieSaveActionPerformed
        if (fieldName.getText().equals("") || fieldBeschreibung.equals("")) {
            showMessageDialog(null, "Pflichtfelder ausfüllen!");
            lblOutput.setForeground(Color.red);
            lblOutput.setText("Fehler!");
        } else {
            boolean ret = false;

            KategorieGrenz kg = new KategorieGrenz();

            int katid = Integer.parseInt(fieldID.getText());
            kg.setKatid(katid);
            kg.setName(fieldName.getText());
            kg.setBeschreibung(fieldBeschreibung.getText());
            kg.setParentkatid(hiddenValueForComboKategorie);
            
            KategorieSteuerung kategoriesteuerung = new KategorieSteuerung();

            ret = kategoriesteuerung.kategorieBearbeiten(kg);

            if (ret == true) {
                lblOutput.setText("Erfolgreich gespeichert");
                FrameKategorieManager.setjLabel3("Erfolgreich gespeichert");
                dispose();

            } else {
                lblOutput.setText("Fehler!");
            }
        }
    }//GEN-LAST:event_kategorieSaveActionPerformed

    private void ComboKategorieActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ComboKategorieActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_ComboKategorieActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FrameKategorieEdit.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FrameKategorieEdit.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FrameKategorieEdit.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FrameKategorieEdit.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {

                new FrameKategorieEdit().setVisible(true);
                
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JComboBox<String> ComboKategorie;
    private javax.swing.JButton close;
    private javax.swing.JTextField fieldBeschreibung;
    private javax.swing.JTextField fieldID;
    private javax.swing.JTextField fieldName;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JButton kategorieSave;
    private javax.swing.JLabel lblOutput;
    // End of variables declaration//GEN-END:variables
}
